/*
 * TOAD -- A Simple and Powerful C++ GUI Toolkit for the X Window System
 * Copyright (C) 1996-98 by Mark-Andr Hopf
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 * MA  02111-1307,  USA
 */

/*
 *
 * New++ -- A modified 'new' to discover memory leaks.
 * Copyright (C) 1996-98 by Mark-Andr Hopf
 * Written 1996-98 by Mark-Andr Hopf
 *
 * To use this feature define `SECURE_NEW' in `toad/debug.hh' and recompile
 * the whole library and your programs.
 *
 */

#ifdef SECURE_NEW
	#include <stdlib.h>
	
	// pre-include STL libraries here to prevent conflicts with the
	// `new' operator
	//--------------------------------------------------------------
	#include <string>
	#include <vector>
	#include <list>
	#include <stack>
	#include <map>
	
	// (you may add other files here)
	
	//--------------------------------------------------------------
	
	struct __struct_toad_new_info
	{
		unsigned long check1;
		const char* file;
		unsigned line;
		size_t size;
		__struct_toad_new_info *next;
		unsigned long check2;
		char real_memory[1];
	};
	extern __struct_toad_new_info *__toad_new_info_list;
	extern __struct_toad_new_info __toad_new_info;
	
	inline __struct_toad_new_info* __proc_toad_new_info(const char* f,unsigned l)
	{
		__toad_new_info.file = f;
		__toad_new_info.line = l;
		return &__toad_new_info;
	}
	
	void* operator new(size_t size,__struct_toad_new_info* info);
	void* operator new[](size_t size,__struct_toad_new_info* info);
	void operator delete(void *ptr);
	void operator delete[](void *ptr);
	
	#define new new(__proc_toad_new_info(__FILE__,__LINE__))
#endif
