/*
 * TOAD -- A Simple and Powerful C++ GUI Toolkit for the X Window System
 * Copyright (C) 1996-99 by Mark-Andr Hopf
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
 * MA  02111-1307,  USA
 */

#include <errno.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>

#define _TOAD_PRIVATE

#include <toad/toad.hh>
#include <toad/dialogeditor/simpledlgeditor.hh>

// main
//----------------------------------------------------------------------------
int main(int argc, char *argv[], char *envv[])
{
	// this is something other OO languages call class initialisation
	TOADBase::Init(argc,argv,envv);

	if (TDialogEditor::running)
		TDialogEditor::SetDialogEditor(new TSimpleDlgEditor());

	int result = ToadMain();

	// remove dialog editor (if any)
	//----------------------------------------
	TDialogEditor::SetDialogEditor(NULL);
	
	TOADBase::Close();

#ifdef SECURE_NEW
	if (__toad_new_info_list!=NULL) {
		printf("\n"
		       "\n"
					 "                             WARNING\n"
					 "\n"
					 "The TOAD memory checker has found memory leaks in your program:\n");
		__struct_toad_new_info *p    = __toad_new_info_list;
		unsigned c=1;
		while(p) {
			printf("  %u. file:%s line:%u (0x%08lx)\n",c,p->file,p->line,(long)p);
			c++;
			p=p->next;
		}
		printf("\n");
	}
#endif

	return result;
}
